#include <string.h>
#include <stdio.h>
#include <ctype.h>

FILE *file=NULL, *fileptk=NULL, *fileinf=NULL, *fileerr=NULL;
int verbose, fileerrors;
extern FILE *yyin;

#define FILEPTK   0
#define FILEINF   1
#define FILEERR   2

static char *fnames[] = { "files.ptk", "files.inf", "files.err", "files.lft", NULL };
static char *help[] = {
  "getuuenc $Revision: 1.4 $",
	" ",
  "author: Sven Goethel", 
  "email:  goethel@sprynet.de",
  " ",
  "copyright: feel free to distribute, but never ever change this program",
  "           without my permission !",
  "           So, send me a email to all of the upper adress,",
	"           to receive my good-will",
  " ",
  "All donations, suggestions and congratulations are welcome",
  " ",
  " ",
  "DESCRIPTION:",
  "============",
  " ",
  "1.) This program scans any ascii-input-stream,",
  "    which contains e-mails. ",
  " ",
  "2.) All uuencode-email-sections will be recognized",
  "    and wrote to an indexed file with the suffix .uue.",
  " ",
  "3.) If the uuencoded-email is split in several email's,",
  "    this program tries to resum the uuencoded-email with the",
  "    next email in the input-stream !!!!!!!!!!!!!!!!!!!!!!!!!",
  " ",
  "4.) Because of 3.), the email-stream MUST be sorted with the",
  "    oldest email first and the newes email at last !!!!!!!!!",
  " ",
  "5.) The generated Files (see i use regular expressions):",
  " ",
  "    '[1-0]+.uue': all the uudecoded result files (UUE)",
  "    '.+.ptk': the ascii-little database: UUE-Files <-> Real Filenames",
  "    '.+.inf': the warning-file for extra information",
  "    '.+.err': the error-file",
	" ",
  "That's it. Have a lot of fun. sven :-)",
	NULL
	};


void fprinthelp(FILE *fp)
{
  int i=0;
	while(help[i]!=NULL) fprintf(fp,"%s\n", help[i++]);
}

int main(int argc, char *argv[])
{
  int i, done, l, idx;
  FILE *in=NULL;

  verbose=0;

  if(argc>2 && strcmp(argv[1],"-v")==0) { verbose=1; idx=2; }
  else idx=1;

  if(argc==2 && strcmp(argv[1],"--help")==0)
  {
    fprinthelp(stdout);
    return 0;
  }
  if(argc-idx!=1)
  {
    printf("usage: %s [-v] <email-stream>\n", argv[0]);
    printf("       or\n");
    printf("       %s --help\n", argv[0]);
    return 1;
  }

  in=fopen(argv[idx],"rb");
  fileptk=fopen(fnames[FILEPTK],"wt");
  fileinf=fopen(fnames[FILEINF],"wt");
  fileerr=fopen(fnames[FILEERR],"wt");

  if(in==NULL||fileptk==NULL||fileinf==NULL||fileerr==NULL)
  {
    printf("can't open files\n");
    return 1;
  }
  else
  {
    if(!verbose) printf("... one star for each recoginzed mail (uuencoded or not)\n");
  }  
  yyin=in;
  yylex();

  fprintf(fileerr, "\n\nErrors : %d\n\n", fileerrors) ;

  fclose(in);
  fclose(fileptk);
  fclose(fileinf);
  fclose(fileerr);
  if(file) fclose(file);

  printf("\n\nErrors : %d\n", fileerrors) ;
  return 0;
}

